﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Tesis_V_6
{
    class inversor
    {
        public static double Fact(double Num)
        {
            int i;
            double acum = 1;

            for (i = 1; i <= Num; i++)
            {

                acum = acum * i;

            }

            return acum;
        }
        //besselI0
        public static double BesselI0(double x)
        {
            double t;
            double numerador;
            double bessel;


            t = x / 3.75;

            if (-3.75 <= x && x <= 3.75)
            {
                bessel = 1 + 3.5156229 * (Math.Pow(t, 2)) + 3.0899424 * (Math.Pow(t, 4)) + 1.2067492 * (Math.Pow(t, 6)) + 0.2659732 * (Math.Pow(t, 8)) + 0.0360768 * (Math.Pow(t, 10)) + 0.0045813 * (Math.Pow(t, 12));
            }
            else
            {
                numerador = 0.39894228 + 0.01328592 * (Math.Pow(t, -1)) + 0.00225319 * (Math.Pow(t, -2)) - 0.00157565 * (Math.Pow(t, -3)) + 0.00916281 * (Math.Pow(t, -4)) - 0.02057706 * (Math.Pow(t, -5)) + 0.02635537 * (Math.Pow(t, -6)) - 0.01647633 * (Math.Pow(t, -7)) + 0.00392377 * (Math.Pow(t, -8));
                bessel = numerador / ((Math.Pow(x, 0.5)) * (Math.Exp(-x)));
            }

            return bessel;

        }

        public static double BesselI1(double x)

        {
            double t;
            double numerador;
            double bessel;


            t = x / 3.75;

            if (-3.75 <= x && x <= 3.75)
            {
                bessel = x * (0.5 + 0.87890594 * (Math.Pow(t, 2)) + 0.51498869 * (Math.Pow(t, 4)) + 0.15084934 * (Math.Pow(t, 6)) + 0.02658733 * (Math.Pow(t, 8)) + 0.00301532 * (Math.Pow(t, 10)) + 0.00032411 * (Math.Pow(t, 12)));
            }
            else
            {
                numerador = 0.39894228 - 0.03988024 * (Math.Pow(t, -1)) - 0.00362018 * (Math.Pow(t, -2)) + 0.00163801 * (Math.Pow(t, -3)) - 0.01031555 * (Math.Pow(t, -4)) + 0.02282967 * (Math.Pow(t, -5)) - 0.02895312 * (Math.Pow(t, -6)) + 0.01787654 * (Math.Pow(t, -7)) - 0.00420059 * (Math.Pow(t, -8));
                bessel = numerador / ((Math.Pow(x, 0.5)) * (Math.Exp(-x)));
            }

            return bessel;
        }

        public static double BesselK0(double x)
        {
            double numerador;
            double bessel;

            if (0 <= x && x <= 2)

            {
                bessel = (-1 * Math.Log(x / 2, Math.E) * BesselI0(x)) - 0.57721566 + 0.4227842 * (Math.Pow(x / 2, 2)) + 0.23069756 * (Math.Pow(x / 2, 4)) + 0.0348859 * (Math.Pow(x / 2, 6)) + 0.00262698 * (Math.Pow(x / 2, 8)) + 0.0001075 * (Math.Pow(x / 2, 10)) + 0.0000074 * (Math.Pow(x / 2, 12));
            }
            else
            {
                numerador = 1.25331414 - 0.07832358 * (2 / x) + 0.02189568 * (Math.Pow(2 / x, 2)) - 0.01062446 * (Math.Pow(2 / x, 3)) + 0.00587872 * (Math.Pow(2 / x, 4)) - 0.0025154 * (Math.Pow(2 / x, 5)) + 0.00053208 * (Math.Pow(2 / x, 6));
                bessel = numerador / (Math.Exp(x) * Math.Pow(x, 0.5));

            }

            return bessel;

        }

        public static double BesselK1(double x)
        {
            double numerador;
            double bessel;

            if (0 <= x && x <= 2)
            {
                bessel = ((x * Math.Log(x / 2, Math.E) * BesselI1(x)) + 1 + 0.15443144 * (Math.Pow(x / 2, 2)) - 0.67278579 * (Math.Pow(x / 2, 4)) - 0.18156897 * (Math.Pow(x / 2, 6)) - 0.01919402 * (Math.Pow(x / 2, 8)) - 0.00110404 * (Math.Pow(x / 2, 10)) - 0.00004686 * (Math.Pow(x / 2, 12))) / x;
            }
            else
            {
                numerador = 1.25331414 + 0.23498619 * (2 / x) - 0.0365562 * (Math.Pow(2 / x, 2)) + 0.01504268 * (Math.Pow(2 / x, 3)) - 0.00780353 * (Math.Pow(2 / x, 4)) + 0.00325614 * (Math.Pow(2 / x, 5)) - 0.00068245 * (Math.Pow(2 / x, 6));
                bessel = numerador / (Math.Exp(x) * Math.Pow(x, 0.5));
            }

            return bessel;

        }


        public static double trapecio(double t, double red, int N)

        {
            double xponem;
            double minimo;
            double indicador;
            int r;
            double acum;
            double trapecio;

            xponem = Math.Log(t, Math.E) / Math.Log(10, Math.E);
            if (xponem < 0)
            {
                xponem = xponem - 1;
            }


            minimo = t - Math.Pow(10, Math.Truncate(xponem));

            if (minimo == 0)
            {
                minimo = t - Math.Pow(10, -1 + Math.Truncate(xponem));
            }


            indicador = (t - minimo) / 5;


            acum = 0;
            for (r = 1; r <= 4; r++)
            {

                acum = acum + ((Math.Log(red, Math.E) - 0.5) / (stehfest(4, minimo + indicador * r, 4, red)));


            }

            trapecio = (((Math.Log(red, Math.E) - 0.5)) / stehfest(N, minimo * 1, 4, red) + (Math.Log(red, Math.E) - 0.5) / stehfest(N, t, 4, red) + 2 * acum) * indicador / 2;

            return trapecio;
        }





























        public static double stehfest(int N, double tD, int PD, double red)

        {

            double a;
            double sum1;
            double sum2;
            double vj;
            double alfa;
            double beta;
            double gama;
            double eta;
            double cte;
            double ki;
            int minimo;
            double st;
            double b;
            double cteq;
            double s;
            int fin = 0;

            a = Math.Log(2, Math.E) / tD;
            sum2 = 0;

            for (int j = 1; j <= 2 * N; j++)
            {


                //minimo = Math.Min(j, N);
                ki = (j + 1) / 2;
                Math.Truncate(ki);

                sum1 = 0;
                //N debe ser entero
                if (j > N)
                {
                    fin = N;
                }
                else
                {
                    fin = j;
                }




                for (int k = (j + 1) / 2; k <= Math.Min(j, N); k++)

                {
                    sum1 = sum1 + (Math.Pow(k, N) * Fact(2 * k) / ((Fact(N - k)) * (Fact(k)) * (Fact(k - 1)) * (Fact(j - k)) * (Fact(2 * k - j))));
                }

                vj = (Math.Pow(-1, N + j)) * sum1;

                if (PD == 1)
                {
                    b = 1 / (0.5 * (Math.Pow(red, 2) - 1) * (Math.Log(red, Math.E) - 0.5));
                    cteq = Math.Log(red, Math.E) - 0.5;
                    s = a * j;
                    alfa = BesselK1(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    beta = (BesselK1(red * Math.Pow(s * b, 0.5)) * BesselI1(Math.Pow(s * b, 0.5))) / (BesselI1(red * Math.Pow(s * b, 0.5)) * BesselI0(Math.Pow(s * b, 0.5)));
                    gama = BesselK0(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    eta = BesselK1(red * Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5));
                    cte = (alfa - beta) / (gama + eta);

                    sum2 = sum2 + vj * (1 / (Math.Pow(s, 0.5))) * cte * cteq * Math.Pow(b, 0.5);
                }
                else if (PD == 2)
                {
                    b = 1 / (0.5 * (Math.Pow(red, 2) - 1) * (Math.Log(red, Math.E) - 0.5));
                    cteq = Math.Log(red, Math.E) - 0.5;
                    s = j * a;
                    alfa = BesselK1(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    beta = (BesselK1(red * Math.Pow(s * b, 0.5)) * BesselI1(Math.Pow(s * b, 0.5))) / (BesselI1(red * Math.Pow(s * b, 0.5)) * BesselI0(Math.Pow(s * b, 0.5)));
                    gama = BesselK0(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    eta = BesselK1(red * Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5));
                    cte = (alfa - beta) / (gama + eta);

                    sum2 = sum2 + vj * (1 / (Math.Pow(s, 0.5) * s)) * cte * cteq * Math.Pow(b, 0.5);
                }

                else if (PD == 4)
                {
                    b = 1 / (0.5 * (Math.Pow(red, 2) - 1) * (Math.Log(red, Math.E) - 0.5));

                    s = j * a;


                    alfa = BesselK1(red * Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5));
                    beta = BesselK0(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    gama = BesselK1(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    eta = (BesselI1(Math.Pow(s * b, 0.5)) * BesselK1(red * Math.Pow(s * b, 0.5))) / ((BesselI0(Math.Pow(s * b, 0.5))) * (BesselI1(Math.Pow(s * b, 0.5))));
                    cte = (alfa + beta) / (gama - eta);

                    sum2 = sum2 + vj * cte * (1 / (s * Math.Pow(s * b, 0.5)));
                }

                else if (PD == 5)
                {
                    b = 1 / (0.5 * (Math.Pow(red, 2) - 1) * (Math.Log(red, Math.E) - 0.5));
                    cteq = Math.Log(red, Math.E) - 0.5;
                    s = j * a;


                    alfa = BesselK1(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    beta = BesselK1(red * Math.Pow(s * b, 0.5)) * BesselI1(Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5)) * BesselI0(Math.Pow(s * b, 0.5));
                    gama = BesselK0(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    eta = BesselK1(red * Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5));
                    cte = (alfa - beta) / (gama + eta);

                    sum2 = sum2 + vj * cte * ((cteq * Math.Pow(b, 0.5)) / (s * Math.Pow(s, 0.5)));
                }



                else if (PD == 6)
                {
                    b = 1 / ((3.1416) * (red * red - 1));
                    s = j * a;
                    alfa = BesselK1(red * Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5));
                    beta = BesselK0(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    gama = BesselK1(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    eta = (BesselI1(red * Math.Pow(s * b, 0.5)) * BesselK1(red * Math.Pow(s * b, 0.5))) / (BesselI0(Math.Pow(s * b, 0.5)) * BesselI1(red * Math.Pow(s * b, 0.5)));
                    cte = (alfa + beta) / (gama - eta);
                    sum2 = sum2 + vj * cte * (1 / (Math.Pow(b * s, 0.5) * s));


                }
                else if (PD == 7)
                {
                    b = 1 / ((3.1416) * (red * red - 1));
                    s = j * a;
                    alfa = BesselK1(red * Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5));
                    beta = BesselK0(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    gama = BesselK1(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    eta = (BesselI1(Math.Pow(s * b, 0.5)) * BesselK1(red * Math.Pow(s * b, 0.5))) / (BesselI0(Math.Pow(s * b, 0.5)) * BesselI1(red * Math.Pow(s * b, 0.5)));

                    cte = (alfa + beta) / (gama - eta);
                    sum2 = sum2 + vj * cte * (1 / (Math.Pow(b * s, 0.5)));
                }
                else if (PD == 8)
                {
                    b = 1 / ((3.1416) * (red * red - 1));
                    s = a * j;
                    alfa = BesselK1(red * Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5));
                    beta = BesselK0(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    gama = BesselK1(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    eta = (BesselI1(red * Math.Pow(s * b, 0.5)) * BesselK1(red * Math.Pow(s * b, 0.5))) / (BesselI0(Math.Pow(s * b, 0.5)) * BesselI1(red * Math.Pow(s * b, 0.5)));
                    cte = (alfa + beta) / (gama - eta);

                    sum2 = sum2 + vj * cte * (1 / (j * j * a * a * Math.Pow(j * a * b, 0.5)));

                }

                else if (PD == 9)
                {
                    s = a * j;
                    alfa = BesselK1(red * Math.Pow(s, 0.5)) / BesselI1(red * Math.Pow(s, 0.5));
                    beta = BesselK0(Math.Pow(s, 0.5)) / BesselI0(Math.Pow(s, 0.5));
                    gama = BesselK1(Math.Pow(s, 0.5)) / BesselI0(Math.Pow(s, 0.5));
                    eta = (BesselI1(Math.Pow(s, 0.5)) * BesselK1(red * Math.Pow(s, 0.5))) / (BesselI0(Math.Pow(s, 0.5)) * BesselI1(red * Math.Pow(s, 0.5)));
                    cte = (alfa + beta) / (gama - eta);

                    sum2 = sum2 + vj * cte * (1 / (s * Math.Pow(s, 0.5)));


                }
                else if (PD == 10)
                {
                    s = a * j;
                    alfa = BesselK1(red * Math.Pow(s, 0.5)) / BesselI1(red * Math.Pow(s, 0.5));
                    beta = BesselK0(Math.Pow(s, 0.5)) / BesselI0(Math.Pow(s, 0.5));
                    gama = BesselK1(Math.Pow(s, 0.5)) / BesselI0(Math.Pow(s, 0.5));
                    eta = (BesselI1(Math.Pow(s, 0.5)) * BesselK1(red * Math.Pow(s, 0.5))) / (BesselI0(Math.Pow(s, 0.5)) * BesselI1(red * Math.Pow(s, 0.5)));
                    cte = (alfa + beta) / (gama - eta);

                    sum2 = sum2 + vj * cte * (1 / (Math.Pow(s, 0.5)));




                }
                else if (PD == 11)
                {

                    s = a * j;
                    alfa = BesselK1(red * Math.Pow(s, 0.5)) / BesselI1(red * Math.Pow(s, 0.5));
                    beta = BesselK0(Math.Pow(s, 0.5)) / BesselI0(Math.Pow(s, 0.5));
                    gama = BesselK1(Math.Pow(s, 0.5)) / BesselI0(Math.Pow(s, 0.5));
                    eta = (BesselI1(Math.Pow(s, 0.5)) * BesselK1(red * Math.Pow(s, 0.5))) / (BesselI0(Math.Pow(s, 0.5)) * BesselI1(red * Math.Pow(s, 0.5)));
                    cte = (alfa + beta) / (gama - eta);

                    sum2 = sum2 + vj * (cte / (s * s * (Math.Pow(s, 0.5))));



                }
                else if (PD == 12)
                {
                    b = 1 / ((3.1416) * (red * red - 1));
                    s = a * j;
                    alfa = BesselK1(red * Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5));
                    beta = BesselK0(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    gama = BesselK1(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    eta = (BesselI1(Math.Pow(s * b, 0.5)) * BesselK1(red * Math.Pow(s * b, 0.5))) / ((BesselI0(Math.Pow(s * b, 0.5))) * (BesselI1(red * Math.Pow(s * b, 0.5))));
                    cte = (alfa + beta) / (gama - eta);

                    sum2 = sum2 + vj * cte * (1 / (s * Math.Pow(s * b, 0.5)));

                }
                else if (PD == 13)
                {
                    b = 1 / ((3.1416) * (red * red - 1));
                    s = a * j;
                    alfa = BesselK1(red * Math.Pow(s * b, 0.5)) / BesselI1(red * Math.Pow(s * b, 0.5));
                    beta = BesselK0(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    gama = BesselK1(Math.Pow(s * b, 0.5)) / BesselI0(Math.Pow(s * b, 0.5));
                    eta = (BesselI1(Math.Pow(s * b, 0.5)) * BesselK1(red * Math.Pow(s * b, 0.5))) / ((BesselI0(Math.Pow(s * b, 0.5))) * (BesselI1(red * Math.Pow(s * b, 0.5))));
                    cte = (alfa + beta) / (gama - eta);

                    sum2 = sum2 + vj * cte * (1 / (s * s * Math.Pow(s * b, 0.5)));
                }



                else
                {

                }
            }

            st = a * sum2;
            return st;

        }





    }
}
