﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Tesis_V_6
{
    public class propdelgas 
    {


        public static double pressurecritic(int caso,  double densi)
        {
            double ppc = 0.0;
             double pressure;
            if (caso == 0)
            {
                ppc = 677 + 15 * densi - 37.5 * (Math.Pow(densi, 2));                
            }
            if (caso == 1)
            {
                ppc = 706 - 51.7 * densi - 11.1 * (Math.Pow(densi, 2));               
            }
            if (caso == 2)
            {
                ppc = 756.8 - 131 * densi - 3.6 * (Math.Pow(densi, 2));               
            }
            pressure = ppc;            
            return pressure;
        }

        public static double temperaturecritic(int caso, double densi)
        {
            double  tpc = 0.0;
            double temperature;
            if (caso == 0)
            {                
                tpc = 168 + 325 * densi - 12.5 * (Math.Pow(densi, 2));
            }
            if (caso == 1)
            {                
                tpc = 187 + 330 * densi - 71.5 * (Math.Pow(densi, 2));
            }
            if (caso == 2)
            {
                tpc = 169.2 + 349.5 * densi - 74 * (Math.Pow(densi, 2));
            }
            temperature = tpc;
            return temperature;
        }

        public static double pseudopressure (double p, double ppc)
        {
            double ppr;           
            ppr = p / ppc;
            return ppr;
        }

        public static double pseudotemp(double t, double tpc)
        {
            double tpr;
            tpr = (t+460) / tpc;
            return tpr;
        }




        //factor z//
        public static double ztest(int caso, double p, double t, double densi)
        {
            double pc,tc,ppr,tpr,ztest;

            pc = pressurecritic(caso, densi);
            tc = temperaturecritic(caso, densi);
            ppr = pseudopressure(p, pc);
            tpr = pseudotemp(t, tc);

            double Zs, Pr, Tr;
            Zs = 1;
            Pr = ppr;
            Tr = tpr;
            double dr, C1, C2, C3, C4, zc, Zdc, Z;
            double A1, A2, A3, A4, A5, A6, A7, A8, a9, a10, a11;

            A1 = 0.3265;
            A2 = -1.07;
            A3 = -0.5339;
            A4 = 0.01569;
            A5 = -0.05165;
            A6 = 0.5475;
            A7 = -0.7361;
            A8 = 0.1844;
            a9 = 0.1056;
            a10 = 0.6134;
            a11 = 0.721;
            C1 = A1 + A2 / Tr + A3 / (Math.Pow(Tr, 3)) + A4 / (Math.Pow(Tr, 4)) + A5 / (Math.Pow(Tr, 5));
            C2 = A6 + A7 / Tr + A8 / (Math.Pow(Tr, 2));
            C3 = a9 * (A7 / Tr + A8 / (Math.Pow(Tr, 2)));
            Z = 0;

            do
            {
                Z = Zs;
                dr = 0.27 * Pr / Z / Tr;
                C4 = a10 * (1 + a11 * (Math.Pow(dr, 2))) * ((Math.Pow(dr, 2)) / ((Math.Pow(Tr, 3))) * Math.Exp(-a11 * (Math.Pow(dr, 2))));
                zc = Z - (1 + C1 * dr + C2 * (Math.Pow(dr, 2)) - C3 * (Math.Pow(dr, 5)) + C4);
                Zdc = 1 + C1 * dr / Z + 2 * C2 * (Math.Pow(dr, 2)) / Z - 5 * C3 * (Math.Pow(dr, 5)) / Z + 2 * a10 * (Math.Pow(dr, 2)) / ((Math.Pow(Tr, 3)) * Z) * (1 + a11 * (Math.Pow(dr, 2)) - (Math.Pow(a11 * Math.Pow(dr, 2), 2))) * Math.Exp(-a11 * (Math.Pow(dr, 2)));
                Zs = Z - (zc / Zdc);
            }
            while (Math.Abs(Zs - Z)< 0.0000001);

            ztest = Zs;


            return ztest;

        }

        //viscosidad del gas
        public static double MLee (double P, double t, double drg, double Z)
        {
            double Mg, R, Rho, K, X, y;

            Mg = drg * 28.966;
            Rho = 1.4935 * (Math.Pow(10, -3)) * P * Mg / Z / (t + 460.67);
            K = (9.4 + 0.02 * Mg) * (Math.Pow((t + 460.67), 1.5)) / (209 + 19 * Mg + (t + 460.67));
            X = 3.5 + 986 / (t + 460.67) + 0.01 * Mg;
            y = 2.4 - 0.2 * X;
            R = K * Math.Exp(X * (Math.Pow(Rho , y))) / (10 * 10 * 10 * 10);

            return R;
        }





    }
}
